* KEPLER.CMD
* Find the ecliptic longitude where mean anomaly and eccentricity are known
* also, ecliptic longitude at perhelion (elp)
* IN : m,ecc,elp
* OUT: lambda
*------------------------------------------------------------------------
* for demonstration, the following memvars are hardwired here:
STORE 3.520839 TO m
STORE 0.016718 TO ecc
STORE 282.596403 TO elp
* now compute the ecliptic longitude, lambda, of the sun on
* July 7, 1978, per the method in Duffett-Smith's Practical Astronomy for
* your Calculator, p 86.
*-------------------------------------------------------------------------
* we begin...
STORE "RAD" TO trigmode
* first guess, m must be in range 0 to 2*pi
STORE m TO e
STORE e TO x
DO sine
STORE e - (ecc * x) - m TO delta
IF delta < 0
   STORE -(delta) TO diff
ELSE
   STORE delta TO diff
ENDIF
DO WHILE diff > .000001
   STORE e TO x
   DO cosine
   STORE e - (delta / (1 - ecc * x)) TO e
   STORE e TO x
   DO sine
   STORE e - (ecc * x) - m TO delta
   IF delta < 0
      STORE -(delta) TO diff
   ELSE
      STORE delta TO diff
   ENDIF
ENDDO
* now have eccentric anomaly in e
STORE (1 + ecc)/(1 - ecc) TO x
DO sqroot
STORE x TO sqr
STORE e/2 TO x
DO tangent
STORE sqr * x TO x
DO arctan
STORE 2 * x TO nu
* now have true anomaly in nu
STORE nu * 180 / 3.14159265 TO nu
STORE nu + elp TO lambda
IF lambda > 360
   STORE lambda - 360 TO lambda
ENDIF
IF lambda < 0
   STORE lambda + 360 TO lambda
ENDIF
? "Ecliptic longitude of Sun on 7/27/78: ",lambda
? "Duffett-Smith's value on p. 86 is   :    123.629912"
RELEASE x,trigmode,sqr,nu,e,delta,diff,fun,arg

e at perhelion (elp)
* IN : m,ecc,elp
* OUT: lambda
*------------------------------------------------------------------------
* for demonstration, the following memvars are hardwired here:
STORE 3.520839 TO m
STORE 0.016718 TO ecc
STORE 282.596403 TO elp
* now compute the ecliptic longitude, lambda, of the sun on
* July 7, 1978, per the method in Duffett-Smith's Practical Astronomy fo